local require = GLOBAL.require

Assets={}

-----按组添加图标
function AddMapGroup(group)
	for entities_count = 1, #group do
		local entity = group[entities_count]
		--添加图标文件.tex和对应的.xml到Assets表中
		-- table.insert(Assets, Asset("IMAGE", "images/" .. entity .. ".tex"))
		table.insert(Assets, Asset("ATLAS", "images/" .. entity .. ".xml"))
		--加载.xml文件到地图集(.xml与对应的.tex同名且在同一目录下)
		AddMinimapAtlas("images/" .. entity .. ".xml")
		--将图标与图标同名的prefab关联
		if 		(not string.find(entity, "___"))	--名字中包含“___”的为自定义图标，没有对应的prefab名
			and	(not string.find(entity, "yiyu_")) --名字中包含“yiyu_”的为自定义图标，没有对应的prefab名
			then
			AddPrefabPostInit(entity, function (inst)
				if inst.MiniMapEntity == nil then
					inst.entity:AddMiniMapEntity()
				end
				inst.MiniMapEntity:SetIcon(inst.prefab .. ".tex")
			end)
		end
	end
end

-- 注意：同组内的图标排列顺序即为地图显示时的堆叠顺序，越靠后越在上方显示
local aggressive_mobs=
{
	"mosquito",--蚊子
	"mosquito_poison",--毒蚊子
	"frog",--青蛙
	"bat",--蝙蝠
	"merm",--鱼人
	"pigguard",--猪人守卫
	"monkey",--猴子
	"primeape",--猴子
	"birchnutdrake",--橡树籽精
	"tallbird",
	"killerbee",
	"snake",
	"snake_poison",
	"spider",
	"spider_dropper",
	"spider_hider",
	"spider_spitter",
	"spider_warrior",
}

local bones=
{
	"houndbone",--狗骨头
	"scorched_skeleton",--骨架烧焦
	"skeleton",--骨架
	"skeleton_player",--骨架玩家
}

local bosses=
{
	"mossling",--小鸭子
	"moose",--卤鸭
	"dragonfly",--蜻蜓
	"bearger",--熊
	"deerclops",--巨鹿
	"warg",--座狼
	"twister",--风暴BOSS
	"twister_seal",
	"tigershark",--虎鲨BOSS
	"sharkitten",--小虎鲨
	"minotaur",--远古犀牛
	"leif",--树精
	"leif_sparse",--稀有树精
	"spiderqueen",--蜘蛛女王
	"treeguard",--椰子树精
	"kraken",--海妖
}

local chester_packim_bones=
{
	"chester_eyebone",--眼骨
	"packim_fishbone",--鱼骨
}

local flowers=
{
	"flower",
	"flower_evil",
}

local friendly_mobs=
{
	"pigman",--猪人
	"wildbore",--野猪人
	"bunnyman",--兔人
	"rocky",--石虾
	"abigail",--阿比盖尔
}

local holes=
{
	"crabhole",--螃蟹洞
	"molehill",--鼹鼠窝
	"rabbithole",--兔子洞
}

local important_mobs=
{
	"ox",--水牛
	"beefalo",--牛
	"babybeefalo",--小牛
	"whale_blue",--蓝鲸
	"whale_white",--白鲸
	"tallbird",--高鸟
	"jellyfish_planted",--水母
	"rainbowjellyfish_planted",--彩虹水母
	"rainbowjellyfish_planted___HIDDEN",--彩虹水母隐藏
	"solofish",--狗鱼
	"fishinhole",--热带鱼群
	"koalefant_summer",--大象
	"koalefant_winter",--冬象
	"lightninggoat",--山羊
	"doydoy",--多多鸟
	"doydoybaby",--小多多鸟
	"ballphin",--黑海豚
	"smallbird",--小高鸟
	"teenbird",--青年高鸟
}

local light_creatures=
{
	"bioluminescence",--荧光生物
	"fireflies",--萤火虫
}
	
local mines=
{
	"magmarock_gold",--熔岩金矿
	"rock2",--金矿
	"coralreef___2",--珊瑚礁2级
	"coralreef___1",--珊瑚礁1级
	"coral_brain_rock___PICKED",--被采集的珊瑚礁大脑
	"limpetrock___FULL",--长满帽贝的帽贝石
}

local mushrooms=
{
	"green_mushroom",--绿蘑菇
	"blue_mushroom",--蓝蘑菇
	"red_mushroom",--红蘑菇
}

local other_items=
{
	"rocks",
	"goldnugget",
	"nitre",
}

local other_mobs=
{
	"mermfisher",--老鱼人
	"little_walrus",--小海象
	"catcoon",--猫
	"grassgekko",--草精
	"slurtle",--尖壳蜗牛
	"snurtle",--圆壳蜗牛
	"robin",--红鸟
	"robin_winter",--冬鸟
	"crow",--乌鸦
	"parrot",--鹦鹉
	"seagull",--海鸥
	"toucan",--巨嘴鸟
	"cormorant",--鸬鹚
	"perd",--火鸡
	"bee",
	"butterfly",
	"rabbit",
	"crab",
	"mole",
}

local seeds=
{
	"seeds",--种子
}

local shadow_creatures=
{
	"crawlinghorror",--影怪1
	"crawlingnightmare",--影怪2
	"nightmarebeak",--尖喙影怪
	"terrorbeak",--尖喙影怪2
	"swimminghorror",--海影怪
}

local structures=
{
	"beebox___1",
	"beebox___2",
	"beebox___3",
	"beebox___BURNT",
}

-- local survival_tools=
-- {
-- }

local suspicious=
{
	"animal_track",--脚印
	"dirtpile",--可疑的土堆
	"whale_bubbles",--鲸鱼泡
}

local things=
{
	"teleportato_box",--零件1
	"teleportato_crank",--零件2
	"teleportato_potato",--零件3
	"teleportato_ring",--零件4
	"teleportato_sw_box",--零件1
	"teleportato_sw_crank",--零件2
	"teleportato_sw_potato",--零件3
	"teleportato_sw_ring",--零件4
}

local tools = 
{
	"axe",
	"goldenaxe",
	"axe_obsidian",
	"pickaxe",
	"goldenpickaxe",
	"shovel",
	"goldenshovel",
	"machete",
	"goldenmachete",
	"machete_obsidian",
	"hammer",
	"pitchfork",
	"razor",
}

local traps = 
{
	"trap___TRIGGERED",--陷阱被触发状态
	"birdtrap___SET",--鸟陷阱放置状态
	"trap_teeth_maxwell",--maxwell陷阱
	"trap_teeth___SET",--狗牙陷阱设置状态
	"trap_teeth___INACTIVE",--狗牙陷阱未设置状态
	"beemine___INACTIVE",--蜜蜂陷阱未设置状态
}

local trees=
{
	"evergreen___4",
	"evergreen___3",
	"evergreen_sparse___3",
	"deciduoustree___3",
	"jungletree___3",
	"palmtree___3",
	"evergreen___2",
	"evergreen_sparse___2",
	"deciduoustree___2",
	"jungletree___2",
	"palmtree___2",
	"evergreen___1",
	"evergreen_sparse___1",
	"deciduoustree___1",
	"jungletree___1",
	"palmtree___1",
	"mangrovetree___3",
	"mangrovetree___2",
	"mangrovetree___1",
	"evergreen___BURNT",
	"deciduoustree___BURNT",
	"marsh_tree___BURNT",
	"jungletree___BURNT",
	"palmtree___BURNT",
	"mangrovetree___BURNT",
	"jungletree___BURNT",
	"livingtree___BURNT",
	"livingjungletree___BURNT",
	"evergreen___ROOT",
	"deciduoustree___ROOT",
	"marsh_tree___ROOT",
	"jungletree___ROOT",
	"palmtree___ROOT",
	"mangrovetree___ROOT",
	"livingtree___ROOT",
	"livingjungletree___ROOT",
	"mushtree_small___ROOT",
	"mushtree_middle___ROOT",
	"mushtree_tall___ROOT",
	"deciduoustree___MONSTER",
	"deciduoustree___MONSTERROOT",
	"cave_banana_tree",
	"cave_banana_tree___BURNT",
	"cave_banana_tree___FRUIT",
	"cave_banana_tree___ROOT",
	"acorn",
	"pinecone",
	"jungletreeseed",
	"coconut",
}

local useful_items=
{
	"seashell_beached",--贝壳
	"flint",--燧石
	"carrot_planted",--萝卜
	"mandrake",--曼德拉草
	"mandrake___ACTIVE",
	"mandrake___PLANTED",
	"waxwelljournal",--麦斯威尔的日志
	"volcanostaff",--火山权杖
	"obsidian",--黑曜石
}

local walls=
{
	"wall_hay",--草墙
	"wall_limestone",--石灰墙
	"wall_ruins",--铥墙
	"wall_stone",--石墙
	"wall_wood",--木墙
	"sandbagsmall",--沙袋
}

local warning_mobs=
{
	"flup",--沼跃鱼
	"worm",--洞穴虫
	"eyeplant",	--眼花召唤的眼睛
	"slurper",--啜食者
	"tentacle",--触手
	"sharx",--海狗
	"hound",--狗
	"icehound",--冰狗
	"firehound",--火狗
	"crocodog",--鳄鱼
	"watercrocodog",--鳄鱼2
	"poisoncrocodog",--鳄鱼3
	"ghost",--幽灵
	"pirateghost",--海盗幽灵
	"knight",--发条骑士
	"knight_nightmare",--发条骑士2
	"rook",--战车
	"rook_nightmare",--战车2
	"bishop",--主教
	"bishop_nightmare",--主教2
	"knightboat",--齿轮船
	"krampus",--坎普斯
	"walrus",--海象
	"dragoon",--小火龙
	"swordfish",--剑鱼
	"kraken_tentacle",--海妖召唤的触手
	"stungray",--臭飞鱼
}

local wild_dens=
{
	"tentacle_pillar",--大触手
	"mooseegg",--卤鸭蛋
	"snakeden",--蛇藤
	"snakeden___PICKED",
	"spiderden",--蜘蛛巢1级
	"spiderden_2",--蜘蛛巢2级
	"spiderden_3",--蜘蛛巢3级
	"spiderhole",--地下蜘蛛洞穴
	"slurtlehole",--蜗牛窝
	"mussel_farm",--贝壳群
	"mussel_farm___HIDDEN",
	"mussel_farm___EMPTY",
	"mussel_farm___SMALL",
	"mussel_farm___MEDIUM",
	"mussel_farm___LARGE",
}

local wild_plants=
{
	"marsh_bush",
	"cactus",
	"cactus___FLOWERED",
	"coffeebush___FRUIT",
	"berrybush___WITHERED",
	"berrybush2___WITHERED",
	"bambootree___WITHERED",
	"coffeebush___WITHERED",
	"grass___WITHERED",
	"sapling___WITHERED",
	"bush_vine___WITHERED",
	"elephantcactus___WITHERED",
	"bambootree___PICKED",
	"berrybush___PICKED",
	"berrybush2___PICKED",
	"bush_vine___PICKED",
	"cactus___PICKED",
	"grass___PICKED",
	"sapling___PICKED",
	"reeds___PICKED",
	"marsh_bush___PICKED",
	"seaweed_planted___PICKED",
	"elephantcactus",
	"elephantcactus_active",
	"elephantcactus_stump",
	"flower_cave_double",--洞穴花2
	"flower_cave_triple",--洞穴花3
	"yiyu_red_mushroom",--采摘过的红蘑菇
	"yiyu_green_mushroom",--采摘过的绿蘑菇
	"yiyu_blue_mushroom",--采摘过的蓝蘑菇
	"yiyu_flower_cave",--采摘过的灯泡花
}

local wild_structures=
{
	"mermhouse_fisher",--鱼人房2
	"pighead",--猪人头棍
	"mermhead",--鱼人头棍
	"wildborehead",--野猪人头棍
	"wallyintro_debris_1",--沉船碎片1
	"wallyintro_debris_2",--沉船碎片2
	"wallyintro_debris_3",--沉船碎片3
	"wallyintro_shipmast",--沉船
	"flotsam",--海上漂浮的物块
	"catcoonden",--猫窝
	"sandbag",--大沙袋
	"sandhill",--沙丘
	"ancient_altar_broken",--损坏的祭坛
	"ancient_altar",--远古祭坛
	"wreck___BOW",
	"wreck___MAST",
	"wreck___MIDSHIP",
	"wreck___STERN",
	"wreck___BOWFULL",
	"wreck___MASTFULL",
	"wreck___MIDSHIPFULL",
	"wreck___STERNFULL",
}

-- 注意：图标的堆叠顺序与加载图标文件的顺序有关
if GetModConfigData("trees") == true then
	AddMapGroup(trees)
	
	--在加载完自定义植物图标后，再次加载原本的minimap里不想被之前添加的内容遮挡的图标
	AddMapGroup({"___minimap"})	
end

if GetModConfigData("aggressive_mobs") == true then
	AddMapGroup(aggressive_mobs)
end

if GetModConfigData("bones") == true then
	AddMapGroup(bones)
end

if GetModConfigData("flowers") == true then
	AddMapGroup(flowers)
end

if GetModConfigData("friendly_mobs") == true then
	AddMapGroup(friendly_mobs)
end

if GetModConfigData("holes") == true then
	AddMapGroup(holes)
end

if GetModConfigData("important_mobs") == true then
	AddMapGroup(important_mobs)
end

if GetModConfigData("light_creatures") == true then
	AddMapGroup(light_creatures)
end

if GetModConfigData("mines") == true then
	AddMapGroup(mines)
end

if GetModConfigData("mushrooms") == true then
	AddMapGroup(mushrooms)
end

if GetModConfigData("other_items") == true then
	AddMapGroup(other_items)
end

if GetModConfigData("other_mobs") == true then
	AddMapGroup(other_mobs)
end

if GetModConfigData("seeds") == true then
	AddMapGroup(seeds)
end

if GetModConfigData("shadow_creatures") == true then
	AddMapGroup(shadow_creatures)
end

-- if GetModConfigData("survival_tools") == true then
	-- AddMapGroup(survival_tools)
-- end

if GetModConfigData("suspicious") == true then
	AddMapGroup(suspicious)
end

if GetModConfigData("things") == true then
	AddMapGroup(things)
end

if GetModConfigData("tools") == true then
	AddMapGroup(tools)
end

if GetModConfigData("traps") == true then
	AddMapGroup(traps)
end

if GetModConfigData("useful_items") == true then
	AddMapGroup(useful_items)
end

if GetModConfigData("walls") == true then
	AddMapGroup(walls)
end

if GetModConfigData("warning_mobs") == true then
	AddMapGroup(warning_mobs)
end

if GetModConfigData("wild_plants") == true then
	AddMapGroup(wild_plants)
end

if GetModConfigData("wild_dens") == true then
	AddMapGroup(wild_dens)
end

if GetModConfigData("wild_structures") == true then
	AddMapGroup(wild_structures)
end

if GetModConfigData("structures") == true then
	AddMapGroup(structures)
end

if GetModConfigData("bosses") == true then
	AddMapGroup(bosses)
end

if GetModConfigData("chester_packim_bones") == true then
	AddMapGroup(chester_packim_bones)
end
--------------------------------------

-----功能：向component源代码文件中的方法old_fn中添加新的代码fn，第一个参数为self.inst
local function inject_compfn(comp, old_fn_name, fn)
	if comp then
		local old_fn = comp[old_fn_name]
		comp[old_fn_name] =  function(self,...)
			local r1,r2,r3,r4,r5,r6,r7,r8,r9
			if old_fn then
				r1,r2,r3,r4,r5,r6,r7,r8,r9 = old_fn(self, ...)
			end
			fn(self.inst, ...)
			return r1,r2,r3,r4,r5,r6,r7,r8,r9
		end
	else
		print("Component file doesn't exist.")
	end
end
------------------------------------------

-----功能：向parent_node下的函数old_fn中添加新的代码fn
local function inject_fn(parent_node, old_fn_name, fn, delay)
	if delay == nil then
		delay = 0
	end
	if parent_node then
		local old_fn = parent_node[old_fn_name]	
		if old_fn then
			parent_node[old_fn_name] =  function(inst, ...)	
				local r1,r2,r3,r4,r5,r6,r7,r8,r9 = old_fn(inst, ...)
				inst:DoTaskInTime(delay, fn)
				return r1,r2,r3,r4,r5,r6,r7,r8,r9
			end
		else
			if delay == 0 then
				parent_node[old_fn_name] = fn
			else
				parent_node[old_fn_name] = function(inst)
					inst:DoTaskInTime(delay, fn)
				end
			end
		end
	else
		print("Parent node doesn't exist.")
	end
end
------------------------------------------


-----添加树的多种状态图标
local tree = 
{
	"evergreen",
	"evergreen_sparse",
	"deciduoustree",
	"marsh_tree",
	"jungletree",
	"palmtree",
	"mangrovetree",
	"livingtree",
	"livingjungletree",
	"cave_banana_tree",
	"mushtree_small",
	"mushtree_middle",
	"mushtree_tall",
}

local function check_tree(inst)
	if inst.prefab == "cave_banana_tree" then
		--print("I was called by cave_banana_tree")
		if inst.stump then
			inst.MiniMapEntity:SetIcon( "cave_banana_tree___ROOT.tex" )
		elseif inst.burnt then
			inst.MiniMapEntity:SetIcon( "cave_banana_tree___BURNT.tex" )
		elseif inst.components.pickable and inst.components.pickable.canbepicked then
			inst.MiniMapEntity:SetIcon( "cave_banana_tree___FRUIT.tex" )
		else
			inst.MiniMapEntity:SetIcon( "cave_banana_tree.tex" )
		end
		return
	end
	if inst.prefab == "mangrovetree" then
		--print("I was called by mangrovetree")
		if inst:HasTag("burnt") then
			inst.MiniMapEntity:SetIcon( "mangrovetree___BURNT.tex" )
		elseif inst.components.growable and inst.components.growable.stage == 1 then
			if inst.components.workable then
				inst.MiniMapEntity:SetIcon( "mangrovetree___3.tex" )
			else
				inst.MiniMapEntity:SetIcon( "mangrovetree___ROOT.tex" )
			end
		elseif inst.components.growable and inst.components.growable.stage == 2 then
			inst.MiniMapEntity:SetIcon( "mangrovetree___1.tex" )
		elseif inst.components.growable and inst.components.growable.stage == 3 then
			inst.MiniMapEntity:SetIcon( "mangrovetree___2.tex" )
		elseif inst.components.growable and inst.components.growable.stage == 4 then
			inst.MiniMapEntity:SetIcon( "mangrovetree___3.tex" )
		end
		return
	end
	if inst:HasTag("stump") then
		if inst.prefab == "evergreen" then
			inst.MiniMapEntity:SetIcon( "evergreen___ROOT.tex" )
		elseif inst.prefab == "evergreen_sparse" then
			inst.MiniMapEntity:SetIcon( "evergreen___ROOT.tex" )
		elseif inst.prefab == "deciduoustree" then
			if inst.monster == true then
				inst.MiniMapEntity:SetIcon( "deciduoustree___MONSTERROOT.tex" )
			else
				inst.MiniMapEntity:SetIcon( "deciduoustree___ROOT.tex" )
			end
		elseif inst.prefab == "marsh_tree" then
			inst.MiniMapEntity:SetIcon( "marsh_tree___ROOT.tex" )
		elseif inst.prefab == "jungletree" then
			inst.MiniMapEntity:SetIcon( "jungletree___ROOT.tex" )
		elseif inst.prefab == "palmtree" then
			inst.MiniMapEntity:SetIcon( "palmtree___ROOT.tex" )
		elseif inst.prefab == "mangrovetree" then
			inst.MiniMapEntity:SetIcon( "mangrovetree___ROOT.tex" )
		elseif inst.prefab == "livingtree" then
			inst.MiniMapEntity:SetIcon( "livingtree___ROOT.tex" )
		elseif inst.prefab == "livingjungletree" then
			inst.MiniMapEntity:SetIcon( "livingjungletree___ROOT.tex" )
		elseif string.find(inst.prefab, "mushtree_") then
			inst.MiniMapEntity:SetIcon( inst.prefab .. "___ROOT.tex" )
		end
	elseif inst:HasTag("burnt") then
		if inst.prefab == "evergreen" then
			inst.MiniMapEntity:SetIcon( "evergreen___BURNT.tex" )
		elseif inst.prefab == "evergreen_sparse" then
			inst.MiniMapEntity:SetIcon( "evergreen___BURNT.tex" )
		elseif inst.prefab == "deciduoustree" then
			inst.MiniMapEntity:SetIcon( "deciduoustree___BURNT.tex" )
		elseif inst.prefab == "marsh_tree" then
			inst.MiniMapEntity:SetIcon( "marsh_tree___BURNT.tex" )
		elseif inst.prefab == "jungletree" then
			inst.MiniMapEntity:SetIcon( "jungletree___BURNT.tex" )
		elseif inst.prefab == "palmtree" then
			inst.MiniMapEntity:SetIcon( "palmtree___BURNT.tex" )
		elseif inst.prefab == "livingtree" then
			inst.MiniMapEntity:SetIcon( "livingtree___BURNT.tex" )
		elseif inst.prefab == "livingjungletree" then
			inst.MiniMapEntity:SetIcon( "livingjungletree___BURNT.tex" )
		end
	else
		if inst.prefab == "evergreen" then
			if inst.components.growable and inst.components.growable.stage == 1 then
				inst.MiniMapEntity:SetIcon( "evergreen___1.tex" )
			elseif inst.components.growable and inst.components.growable.stage == 2 then
				inst.MiniMapEntity:SetIcon( "evergreen___2.tex" )
			elseif inst.components.growable and inst.components.growable.stage == 3 then
				inst.MiniMapEntity:SetIcon( "evergreen___3.tex" )
			elseif inst.components.growable and inst.components.growable.stage == 4 then
				inst.MiniMapEntity:SetIcon( "evergreen___4.tex" )
			end
		elseif inst.prefab == "evergreen_sparse" then
			if inst.components.growable and inst.components.growable.stage == 1 then
				inst.MiniMapEntity:SetIcon( "evergreen_sparse___1.tex" )
			elseif inst.components.growable and inst.components.growable.stage == 2 then
				inst.MiniMapEntity:SetIcon( "evergreen_sparse___2.tex" )
			elseif inst.components.growable and inst.components.growable.stage == 3 then
				inst.MiniMapEntity:SetIcon( "evergreen_sparse___3.tex" )
			elseif inst.components.growable and inst.components.growable.stage == 4 then
				inst.MiniMapEntity:SetIcon( "evergreen___4.tex" )
			end
		elseif inst.prefab == "deciduoustree" then
			if inst.monster == true then
				inst.MiniMapEntity:SetIcon( "deciduoustree___MONSTER.tex" )
			elseif inst.components.growable and inst.components.growable.stage == 1 then
				inst.MiniMapEntity:SetIcon( "deciduoustree___1.tex" )
			elseif inst.components.growable and inst.components.growable.stage == 2 then
				inst.MiniMapEntity:SetIcon( "deciduoustree___2.tex" )
			elseif inst.components.growable and inst.components.growable.stage == 3 then
				inst.MiniMapEntity:SetIcon( "deciduoustree___3.tex" )
			end
		elseif inst.prefab == "jungletree" then
			if inst.components.growable and inst.components.growable.stage == 1 then
				inst.MiniMapEntity:SetIcon( "jungletree___1.tex" )
			elseif inst.components.growable and inst.components.growable.stage == 2 then
				inst.MiniMapEntity:SetIcon( "jungletree___2.tex" )
			elseif inst.components.growable and inst.components.growable.stage == 3 then
				inst.MiniMapEntity:SetIcon( "jungletree___3.tex" )
			end
		elseif inst.prefab == "palmtree" then
			if inst.components.growable and inst.components.growable.stage == 1 then
				inst.MiniMapEntity:SetIcon( "palmtree___1.tex" )
			elseif inst.components.growable and inst.components.growable.stage == 2 then
				inst.MiniMapEntity:SetIcon( "palmtree___2.tex" )
			elseif inst.components.growable and inst.components.growable.stage == 3 then
				inst.MiniMapEntity:SetIcon( "palmtree___3.tex" )
			end
		end
	end
end

if GetModConfigData("wild_plants") == true then
	for k,v in pairs(tree) do
		AddPrefabPostInit(v,function(inst)
			inst:DoTaskInTime(0,check_tree)
			
			-- 对于可成长的树，成长时执行
			if inst.components.growable then
				-- 成长时
				inject_fn(inst.components.growable, "ongrowthfn", check_tree)
			end
			
			--对于可被风刮倒的树，SW DLC
			if inst.components.blowinwindgust then
				--被风刮倒时
				inject_fn(inst.components.blowinwindgust, "destroyfn", check_tree)
			end
			
			--对于可被海浪冲倒的树，SW DLC
			if inst.components.waveobstacle then
				--被海浪冲倒时
				inject_fn(inst.components.waveobstacle, "ondestroyfn", check_tree)
			end
		end)
	end
	
	--用于处理除了香蕉树外的其他树被烧完被砍完，除了红树被砍完
	local work = require "components/workable"
	inject_compfn(work,"SetOnFinishCallback",function(inst)
		inst:DoTaskInTime(0,check_tree)
	end)
	
	--用于处理香蕉树
	AddPrefabPostInit("cave_banana_tree", function(inst)
		if inst.components.burnable then
			-- 树烧完
			inject_fn(inst.components.burnable, "onburnt", check_tree)
		end
		
		if inst.components.workable then
			-- 树砍完
			inject_fn(inst.components.workable, "onfinish", check_tree)
		end
			
		--对于可采集的树
		if inst.components.pickable then
			--没有果实时
			inject_fn(inst.components.pickable, "makeemptyfn", check_tree)
			--有果实时
			inject_fn(inst.components.pickable, "makefullfn", check_tree)
			--采集时
			inject_fn(inst.components.pickable, "onpickedfn", check_tree)
			--长出果实时
			inject_fn(inst.components.pickable, "onregenfn", check_tree)
		end
	end)
	
	--用于处理红树
	AddPrefabPostInit("mangrovetree", function(inst)
		if inst.components.workable then
			-- 树砍完
			inject_fn(inst.components.workable, "onfinish", check_tree)
		end
	end)
end
------------------------------------------


-----添加树幼苗状态图标
local tree_seed = 
{
	"acorn",
	"pinecone",
	"jungletreeseed",
	"coconut",
}

local function check_tree_seed(inst)
	if inst.components.inventoryitem then
		inst.MiniMapEntity:SetIcon( "" )
	else	--刚种的树
		if inst.prefab == "acorn" then
			inst.MiniMapEntity:SetIcon( "acorn.tex" )
		elseif inst.prefab == "pinecone" then
			inst.MiniMapEntity:SetIcon( "pinecone.tex" )
		elseif inst.prefab == "jungletreeseed" then
			inst.MiniMapEntity:SetIcon( "jungletreeseed.tex" )
		elseif inst.prefab == "coconut" then
			inst.MiniMapEntity:SetIcon( "coconut.tex" )
		end
	end
end

if GetModConfigData("wild_plants") == true then
	for k,v in pairs(tree_seed) do
		AddPrefabPostInit(v,function(inst)
			inst:DoTaskInTime(0,check_tree_seed)

			--播种时
			inject_fn(inst.components.deployable, "ondeploy", check_tree_seed)
		end)
	end
end
--------------------------------------


-----添加可采集的植物的多种状态图标
local plant = 
{
	"grass",
	"sapling",
	"reeds",
	"seaweed_planted",
	"bambootree",
	"red_mushroom",
	"green_mushroom",
	"blue_mushroom",
	"berrybush",--浆果丛
	"berrybush2",--浆果丛2
	"flower_cave",
	"flower_cave_double",
	"flower_cave_triple",
	"cactus",
	"bush_vine",
	"coffeebush",
	"elephantcactus",
	"marsh_bush",
	"snakeden"
}

local function check_plant(inst)
	if 		(inst.components.pickable and inst.components.pickable:CanBeFertilized()) 
		or	(inst.components.hackable and inst.components.hackable:CanBeFertilized()) then
		if inst.prefab == "grass" then
			inst.MiniMapEntity:SetIcon( "grass___WITHERED.tex" )
		elseif inst.prefab == "sapling" then
			inst.MiniMapEntity:SetIcon( "sapling___WITHERED.tex" )
		elseif inst.prefab == "bambootree" then
			inst.MiniMapEntity:SetIcon( "bambootree___WITHERED.tex" )
		elseif string.find(inst.prefab, "berrybush") then
			inst.MiniMapEntity:SetIcon( inst.prefab .. "___WITHERED.tex" )
		elseif inst.prefab == "bush_vine" then
			inst.MiniMapEntity:SetIcon( "bush_vine___WITHERED.tex" )
		elseif inst.prefab == "coffeebush" then
			inst.MiniMapEntity:SetIcon( "coffeebush___WITHERED.tex" )
		elseif inst.prefab == "elephantcactus" then
			inst.MiniMapEntity:SetIcon( "elephantcactus___WITHERED.tex" )
		end
	elseif 	(inst.components.pickable and inst.components.pickable.canbepicked) 
		or	(inst.components.hackable and inst.components.hackable.canbehacked) then
		if inst.prefab == "grass" then
			inst.MiniMapEntity:SetIcon( "grass.png" )
		elseif inst.prefab == "sapling" then
			inst.MiniMapEntity:SetIcon( "sapling.png" )
		elseif inst.prefab == "reeds" then
			inst.MiniMapEntity:SetIcon( "reeds.png" )
		elseif inst.prefab == "seaweed_planted" then
			inst.MiniMapEntity:SetIcon( "seaweed.png" )
		elseif inst.prefab == "bambootree" then
			inst.MiniMapEntity:SetIcon( "bambootree.png" )
		elseif string.find(inst.prefab, "_mushroom") then
			inst.MiniMapEntity:SetIcon( inst.prefab .. ".tex" )
		elseif string.find(inst.prefab, "berrybush") then
			inst.MiniMapEntity:SetIcon( inst.prefab .. ".png" )
		elseif inst.prefab == "flower_cave" then
			inst.MiniMapEntity:SetIcon( "bulb_plant.png" )
		elseif string.find(inst.prefab, "flower_cave") then
			inst.MiniMapEntity:SetIcon( inst.prefab .. ".tex" )
		elseif inst.prefab == "cactus" then
			if inst.has_flower then 
				inst.MiniMapEntity:SetIcon( "cactus___FLOWERED.tex" )
			else
				inst.MiniMapEntity:SetIcon( "cactus.tex" )
			end
		elseif inst.prefab == "bush_vine" then
			inst.MiniMapEntity:SetIcon( "bushVine.png" )
		elseif inst.prefab == "coffeebush" then
			inst.MiniMapEntity:SetIcon( "coffeebush___FRUIT.tex" )
		elseif inst.prefab == "elephantcactus" then
			inst.MiniMapEntity:SetIcon( "elephantcactus.tex" )
		elseif inst.prefab == "marsh_bush" then
			inst.MiniMapEntity:SetIcon( "marsh_bush.tex" )
		end
	elseif 	(inst.components.pickable and inst.components.pickable.canbepicked == false) 
		or	(inst.components.hackable and inst.components.hackable.canbehacked == false) then
		if inst.prefab == "grass" then
			inst.MiniMapEntity:SetIcon( "grass___PICKED.tex" )
		elseif inst.prefab == "sapling" then
			inst.MiniMapEntity:SetIcon( "sapling___PICKED.tex" )
		elseif inst.prefab == "reeds" then
			inst.MiniMapEntity:SetIcon( "reeds___PICKED.tex" )
		elseif inst.prefab == "seaweed_planted" then
			inst.MiniMapEntity:SetIcon( "seaweed_planted___PICKED.tex" )
		elseif inst.prefab == "bambootree" then
			inst.MiniMapEntity:SetIcon( "bambootree___PICKED.tex" )
		elseif string.find(inst.prefab, "_mushroom") then
			inst.MiniMapEntity:SetIcon( "yiyu_" .. inst.prefab .. ".tex" )
		elseif string.find(inst.prefab, "berrybush") then
			inst.MiniMapEntity:SetIcon( inst.prefab .. "___PICKED.tex" )
		elseif string.find(inst.prefab, "flower_cave") then
			inst.MiniMapEntity:SetIcon( "yiyu_flower_cave.tex" )
		elseif inst.prefab == "cactus" then
			inst.MiniMapEntity:SetIcon( "cactus___PICKED.tex" )
		elseif inst.prefab == "bush_vine" then
			inst.MiniMapEntity:SetIcon( "bush_vine___PICKED.tex" )
		elseif inst.prefab == "coffeebush" then
			inst.MiniMapEntity:SetIcon( "coffeebush.png" )
		elseif inst.prefab == "elephantcactus" then
			inst.MiniMapEntity:SetIcon( "elephantcactus_stump.tex" )
		elseif inst.prefab == "marsh_bush" then
			inst.MiniMapEntity:SetIcon( "marsh_bush___PICKED.tex" )
		end
	end
end

if GetModConfigData("wild_plants") == true then
	for k,v in pairs(plant) do
		AddPrefabPostInit(v,function(inst)
			inst:DoTaskInTime(0,check_plant)
			
			--对于可采集的植物
			if inst.components.pickable then
				--没有果实时
				inject_fn(inst.components.pickable, "makeemptyfn", check_plant)
				--有果实时
				inject_fn(inst.components.pickable, "makefullfn", check_plant)
				--采集时
				inject_fn(inst.components.pickable, "onpickedfn", check_plant)
				--长出果实时
				inject_fn(inst.components.pickable, "onregenfn", check_plant)
				--变为缺营养状态时
				inject_fn(inst.components.pickable, "makebarrenfn", check_plant)
				--被移植时
				inject_fn(inst.components.pickable, "ontransplantfn", check_plant)
				
				
			--对于可砍的植物，SW DLC
			elseif inst.components.hackable then
				--没有果实时
				inject_fn(inst.components.hackable, "makeemptyfn", check_plant)
				--有果实时
				inject_fn(inst.components.hackable, "makefullfn", check_plant)
				--采集时
				inject_fn(inst.components.hackable, "onhackedfn", check_plant)
				--长出果实时
				inject_fn(inst.components.hackable, "onregenfn", check_plant)
				--变为缺营养状态时
				inject_fn(inst.components.hackable, "makebarrenfn", check_plant)
				--被移植时
				inject_fn(inst.components.hackable, "ontransplantfn", check_plant)
			end
			
			--对于可被风刮倒的植物，SW DLC
			if inst.components.blowinwindgust then
				--被风刮倒时
				inject_fn(inst.components.blowinwindgust, "destroyfn", check_plant)
			end
		end)
	end
	
	--为仙人掌在其醒着时添加状态图标检测函数
	AddPrefabPostInit("cactus" ,function(inst)
		inject_fn(inst, "OnEntityWake", check_plant)
	end)
end
------------------------------------------


----—增加蛇藤状态图标显示，SW DLC
local function check_snakeden(inst)
--	print("cheakcheakcheak>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>")
	if inst.components.hackable and inst.components.hackable.canbehacked then
		inst.MiniMapEntity:SetIcon( "snakeden.tex" )
	elseif inst.components.hackable and inst.components.hackable.canbehacked == false then
		inst.MiniMapEntity:SetIcon( "snakeden___PICKED.tex" )
	end
end

if GetModConfigData("wild_dens") == true then
	AddPrefabPostInit("snakeden", function(inst)
		inst:DoTaskInTime(0,check_snakeden)
		
		if inst.components.hackable then
			--没有果实时
			inject_fn(inst.components.hackable, "makeemptyfn", check_snakeden)
			--有果实时
			inject_fn(inst.components.hackable, "makefullfn", check_snakeden)
			--采集时
			inject_fn(inst.components.hackable, "onhackedfn", check_snakeden)
			--长出果实时
			inject_fn(inst.components.hackable, "onregenfn", check_snakeden)
		end

		if inst.components.blowinwindgust then
			--被风刮倒时
			inject_fn(inst.components.blowinwindgust, "destroyfn", check_snakeden)
		end
	end)
end
--------------------------------------


----—增加蜘蛛蛋状态图标显示
local spiderden=
{
	"spiderden",
	"spiderden_2",
	"spiderden_3",
}

local function check_spiderden(inst)
--	print("cheakcheakcheak>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>")
	if inst.data.stage == 1 then
		inst.MiniMapEntity:SetIcon( "spiderden.tex" )
	elseif inst.data.stage == 2 then
		inst.MiniMapEntity:SetIcon( "spiderden_2.tex" )
	elseif inst.data.stage == 3 then
		inst.MiniMapEntity:SetIcon( "spiderden_3.tex" )
	end
end

if GetModConfigData("wild_dens") == true then
	for k,v in pairs(spiderden) do
		AddPrefabPostInit(v,function(inst)
			inst:DoTaskInTime(0,check_spiderden)
			
			--成长时
			inject_fn(inst.components.growable, "ongrowthfn", check_spiderden)
		end)
	end
end
--------------------------------------

----—增加远古建筑等级图标显示
local ancient_altar=
{
	"ancient_altar",
	"ancient_altar_broken",
}

local function check_ancient_altar(inst)
--	print("cheakcheakcheak>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>")
	if inst.state == true then
		inst.MiniMapEntity:SetIcon( "ancient_altar.tex" )
	else
		inst.MiniMapEntity:SetIcon( "ancient_altar_broken.tex" )
	end
end

if GetModConfigData("wild_structures") == true then
	for k,v in pairs(ancient_altar) do
		AddPrefabPostInit(v,function(inst)
			inst:DoTaskInTime(0,check_ancient_altar)
			
			--修理时
			inject_fn(inst.components.repairable, "onrepaired", check_ancient_altar)
			
			--被锤子砸时
			inject_fn(inst.components.workable, "onwork", check_ancient_altar)
		end)
	end

end
--------------------------------------


----—增加贝壳场状态图标显示
local function check_mussel_farm(inst)
--	print("cheakcheakcheak>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>")
	--inst.components.growable.stage
	--1 Hidden 刚收获完
	--2	Underwater
	--3 Empty 插棍子
	--4 Small
	--5 Medium
	--6 Large
	if inst.components.growable and inst.components.growable.stage == 1 then
		inst.MiniMapEntity:SetIcon( "mussel_farm___HIDDEN.tex" )
	elseif inst.components.growable and inst.components.growable.stage == 2 then
		inst.MiniMapEntity:SetIcon( "mussel_farm.tex" )
	elseif inst.components.growable and inst.components.growable.stage == 3 then
		inst.MiniMapEntity:SetIcon( "mussel_farm___EMPTY.tex" )
	elseif inst.components.growable and inst.components.growable.stage == 4 then
		inst.MiniMapEntity:SetIcon( "mussel_farm___SMALL.tex" )
	elseif inst.components.growable and inst.components.growable.stage == 5 then
		inst.MiniMapEntity:SetIcon( "mussel_farm___MEDIUM.tex" )
	elseif inst.components.growable and inst.components.growable.stage == 6 then
		inst.MiniMapEntity:SetIcon( "mussel_farm___LARGE.tex" )
	end
	inst.MiniMapEntity:SetEnabled(true)
end

if GetModConfigData("wild_dens") == true then
	AddPrefabPostInit("mussel_farm", function(inst)
		inst:DoTaskInTime(0,check_mussel_farm)
		
		--成长时
		inject_fn(inst.components.growable, "ongrowthfn", check_mussel_farm)
		
		--插棍子
		inject_fn(inst.components.stickable, "onpoked", check_mussel_farm)
		
		--变为隐藏
		inject_fn(inst.components.growable.stages[1], "fn", check_mussel_farm)
	end)
end
--------------------------------------


----—增加陷阱、海陷阱、鸟陷阱状态图标显示
local trap=
{
	"trap",
	"seatrap",
	"birdtrap",
}

local function check_trap(inst)
	if inst.components.trap.issprung == true then
		if inst.prefab == "trap" or inst.prefab == "seatrap" then
			inst.MiniMapEntity:SetIcon( "trap___TRIGGERED.tex" )
		elseif inst.prefab == "birdtrap" then
			inst.MiniMapEntity:SetIcon( "birdtrap.png" )
		end
	else
		if inst.prefab == "trap" or inst.prefab == "seatrap" then
			inst.MiniMapEntity:SetIcon( "rabbittrap.png" )
		elseif inst.prefab == "birdtrap" then
			inst.MiniMapEntity:SetIcon( "birdtrap___SET.tex" )
		end
	end
end

if GetModConfigData("traps") == true then
	for k,v in pairs(trap) do
		AddPrefabPostInit(v,function(inst)
			inst:DoTaskInTime(0,check_trap)
			
			local comp_file = require "components/trap"
			--放置陷阱时
			inject_compfn(comp_file, "Set", check_trap)

			--陷阱被触发时
			inject_compfn(comp_file, "DoSpring", check_trap)
		end)
	end
end
--------------------------------------


----—增加狗牙陷阱、蜜蜂陷阱状态图标显示
local mine=
{
	"trap_teeth",
	"beemine",
}

local function check_mine(inst)
	if inst.prefab == "trap_teeth" then
		if inst.components.mine.inactive == true then
			inst.MiniMapEntity:SetIcon( "trap_teeth___INACTIVE.tex" )
		else
			if inst.components.mine.issprung == true then
				inst.MiniMapEntity:SetIcon( "toothtrap.png" )
			else
				inst.MiniMapEntity:SetIcon( "trap_teeth___SET.tex" )
			end
		end
	elseif inst.prefab == "beemine" then
		if inst.components.mine.inactive == true then
			inst.MiniMapEntity:SetIcon( "beemine___INACTIVE.tex" )
		else
			inst.MiniMapEntity:SetIcon( "beemine.png" )
		end
	end
end

if GetModConfigData("traps") == true then
	for k,v in pairs(trap) do
		AddPrefabPostInit(v,function(inst)
			inst:DoTaskInTime(0,check_mine)
			
			local comp_file = require "components/mine"
			--放置陷阱激活时
			inject_compfn(comp_file, "Reset", check_mine)

			--陷阱被触发时
			inject_compfn(comp_file, "Explode", check_mine)
			
			--陷阱放在地下未激活时
			inject_compfn(comp_file, "Deactivate", check_mine)
		end)
	end
end
--------------------------------------


-----添加可采集矿物的多种状态图标
local pickable_mineral = 
{
	"coral_brain_rock",
	"limpetrock",
}

local function check_mineral(inst)
	if 	inst.components.pickable and inst.components.pickable.canbepicked then
		if inst.prefab == "coral_brain_rock" then
			inst.MiniMapEntity:SetIcon( "coral_brain_rock.png" )
		elseif inst.prefab == "limpetrock" then
			inst.MiniMapEntity:SetIcon( "limpetrock___FULL.tex" )
		end
	else
		if inst.prefab == "coral_brain_rock" then
			inst.MiniMapEntity:SetIcon( "coral_brain_rock___PICKED.tex" )
		elseif inst.prefab == "limpetrock" then
			inst.MiniMapEntity:SetIcon( "limpetRock.png" )
		end
	end
end

if GetModConfigData("mines") == true then
	for k,v in pairs(pickable_mineral) do
		AddPrefabPostInit(v,function(inst)
			inst:DoTaskInTime(0,check_mineral)
			
			--对于可采集的矿物
			if inst.components.pickable then
				--没有果实时
				inject_fn(inst.components.pickable, "makeemptyfn", check_mineral)
				--有果实时
				inject_fn(inst.components.pickable, "makefullfn", check_mineral)
				--采集时
				inject_fn(inst.components.pickable, "onpickedfn", check_mineral)
				--长出果实时
				inject_fn(inst.components.pickable, "onregenfn", check_mineral)
			end
		end)
	end
end
------------------------------------------


-----添加可采集的沉船的多种状态图标
local function check_wreck(inst)
	if 	inst.components.pickable and inst.components.pickable.canbepicked then
		if inst.wrecktype == "bow" then
			inst.MiniMapEntity:SetIcon( "wreck___BOWFULL.tex" )
		elseif inst.wrecktype == "midship" then
			inst.MiniMapEntity:SetIcon( "wreck___MIDSHIPFULL.tex" )
		elseif inst.wrecktype == "stern" then
			inst.MiniMapEntity:SetIcon( "wreck___STERNFULL.tex" )
		elseif inst.wrecktype == "mast" then
			inst.MiniMapEntity:SetIcon( "wreck___MASTFULL.tex" )
		end
	else
		if inst.wrecktype == "bow" then
			inst.MiniMapEntity:SetIcon( "wreck___BOW.tex" )
		elseif inst.wrecktype == "midship" then
			inst.MiniMapEntity:SetIcon( "wreck___MIDSHIP.tex" )
		elseif inst.wrecktype == "stern" then
			inst.MiniMapEntity:SetIcon( "wreck___STERN.tex" )
		elseif inst.wrecktype == "mast" then
			inst.MiniMapEntity:SetIcon( "wreck___MAST.tex" )
		end
	end
end

if GetModConfigData("wild_structures") == true then
	AddPrefabPostInit("wreck", function(inst)
		inst:DoTaskInTime(0,check_wreck)
		
		--对于可采集的沉船
		if inst.components.pickable then
			--没有果实时
			inject_fn(inst.components.pickable, "makeemptyfn", check_wreck)
			--有果实时
			inject_fn(inst.components.pickable, "makefullfn", check_wreck)
			--采集时
			inject_fn(inst.components.pickable, "onpickedfn", check_wreck)
			--长出果实时
			inject_fn(inst.components.pickable, "onregenfn", check_wreck)
		end
	end)
end
------------------------------------------


-----添加珊瑚礁的多种状态图标
local function check_coralreef(inst)
	if inst.components.growable and inst.components.growable.stage == 1 then
		inst.MiniMapEntity:SetIcon( "coralreef___1.tex" )
	elseif inst.components.growable and inst.components.growable.stage == 2 then
		inst.MiniMapEntity:SetIcon( "coralreef___2.tex" )
	elseif inst.components.growable and inst.components.growable.stage == 3 then
		inst.MiniMapEntity:SetIcon( "coral_rock.png" )
	end
end

if GetModConfigData("mines") == true then
	AddPrefabPostInit("coralreef", function(inst)
		inst:DoTaskInTime(0,check_coralreef)
		
		if inst.components.growable then
			--珊瑚礁成长时
			inject_fn(inst.components.growable, "ongrowthfn", check_coralreef)
		end
		
		if inst.components.workable then
			--珊瑚礁被开采时
			inject_fn(inst.components.workable, "onwork", check_coralreef)
		end
	end)
end
------------------------------------------


-----添加蜂箱的多种状态图标
local function check_beebox(inst)
	if inst:HasTag("burnt") then
		inst.MiniMapEntity:SetIcon( "beebox___BURNT.tex" )
		inst.MiniMapEntity:SetEnabled(true)
	elseif inst.components.harvestable and inst.components.harvestable.produce >= 6 then
		inst.MiniMapEntity:SetIcon( "beebox___3.tex" )
	elseif inst.components.harvestable and inst.components.harvestable.produce >= 3 then
		inst.MiniMapEntity:SetIcon( "beebox___2.tex" )
	elseif inst.components.harvestable and inst.components.harvestable.produce >= 1 then
		inst.MiniMapEntity:SetIcon( "beebox___1.tex" )
	else
		inst.MiniMapEntity:SetIcon( "beebox.png" )
	end
end

if GetModConfigData("structures") == true then
	AddPrefabPostInit("beebox", function(inst)
		inst:DoTaskInTime(0,check_beebox)
		
		if inst.components.harvestable then
			--蜂箱成长时
			inject_fn(inst.components.harvestable, "ongrowfn", check_beebox)
			--蜂箱被收获时
			inject_fn(inst.components.harvestable, "onharvestfn", check_beebox)
		end
		
		if inst.components.burnable then
			--蜂箱被烧毁时
			inject_fn(inst.components.burnable, "onburnt", check_beebox)
		end
	end)
end
------------------------------------------


-----添加彩虹水母显隐状态图标
local function check_rainbowjellyfish(inst)
	if inst.hidden then 
		inst.MiniMapEntity:SetIcon( "rainbowjellyfish_planted___HIDDEN.tex" )
	else
		inst.MiniMapEntity:SetIcon( "rainbowjellyfish_planted.tex" )
	end
end

if GetModConfigData("important_mobs") == true then
	AddPrefabPostInit("rainbowjellyfish_planted", function(inst)
		inst:DoTaskInTime(0,check_rainbowjellyfish)
		
		--彩虹水母醒来时
		inject_fn(inst, "OnEntityWake", check_rainbowjellyfish)
		--彩虹水母睡着时
		inject_fn(inst, "OnEntitySleep", check_rainbowjellyfish)
	end)
end
------------------------------------------




-- -----添加曼德拉草的多种状态图标
-- local function check_mandrake(inst)
	-- if inst:HasTag("nosteal") and not inst:HasTag("picked") then	--种植状态
		-- inst.MiniMapEntity:SetIcon( "mandrake___PLANTED.tex" )
	-- elseif inst:HasTag("nosteal") and inst:HasTag("picked") then	--跟随状态
		-- inst.MiniMapEntity:SetIcon( "mandrake___ACTIVE.tex" )
	-- else	--物品状态
		-- inst.MiniMapEntity:SetIcon( "mandrake.tex" )
	-- end
-- end

-- if GetModConfigData("useful_items") == true then
	-- AddPrefabPostInit("mandrake", function(inst)
		-- inst:DoTaskInTime(0,check_mandrake)
		
		-- --开始跟随玩家时
		-- --inject_fn(inst, "MakeFollowerFn", check_mandrake)
		
		-- -- if inst.components.pickable then
			-- -- --采集完成时
			-- -- inject_fn(inst.components.pickable, "onpickedfn", check_mandrake)
			
		-- -- end
		-- inst:ListenForEvent("death", function (inst) inst:DoTaskInTime(2, check_mandrake) end)
		-- inst:ListenForEvent("onpickup", function (inst) inst:DoTaskInTime(2, check_mandrake) end)
		-- inst:ListenForEvent("daytime", function (inst) inst:DoTaskInTime(2, check_mandrake) end)
	-- end)
-- end
-- ------------------------------------------

